// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from mavros_msgs:srv/CommandTriggerControl.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "mavros_msgs/srv/command_trigger_control.h"


#ifndef MAVROS_MSGS__SRV__DETAIL__COMMAND_TRIGGER_CONTROL__FUNCTIONS_H_
#define MAVROS_MSGS__SRV__DETAIL__COMMAND_TRIGGER_CONTROL__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/action_type_support_struct.h"
#include "rosidl_runtime_c/message_type_support_struct.h"
#include "rosidl_runtime_c/service_type_support_struct.h"
#include "rosidl_runtime_c/type_description/type_description__struct.h"
#include "rosidl_runtime_c/type_description/type_source__struct.h"
#include "rosidl_runtime_c/type_hash.h"
#include "rosidl_runtime_c/visibility_control.h"
#include "mavros_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "mavros_msgs/srv/detail/command_trigger_control__struct.h"

/// Retrieve pointer to the hash of the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_mavros_msgs
const rosidl_type_hash_t *
mavros_msgs__srv__CommandTriggerControl__get_type_hash(
  const rosidl_service_type_support_t * type_support);

/// Retrieve pointer to the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_mavros_msgs
const rosidl_runtime_c__type_description__TypeDescription *
mavros_msgs__srv__CommandTriggerControl__get_type_description(
  const rosidl_service_type_support_t * type_support);

/// Retrieve pointer to the single raw source text that defined this type.
ROSIDL_GENERATOR_C_PUBLIC_mavros_msgs
const rosidl_runtime_c__type_description__TypeSource *
mavros_msgs__srv__CommandTriggerControl__get_individual_type_description_source(
  const rosidl_service_type_support_t * type_support);

/// Retrieve pointer to the recursive raw sources that defined the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_mavros_msgs
const rosidl_runtime_c__type_description__TypeSource__Sequence *
mavros_msgs__srv__CommandTriggerControl__get_type_description_sources(
  const rosidl_service_type_support_t * type_support);

/// Initialize srv/CommandTriggerControl message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * mavros_msgs__srv__CommandTriggerControl_Request
 * )) before or use
 * mavros_msgs__srv__CommandTriggerControl_Request__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_mavros_msgs
bool
mavros_msgs__srv__CommandTriggerControl_Request__init(mavros_msgs__srv__CommandTriggerControl_Request * msg);

/// Finalize srv/CommandTriggerControl message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_mavros_msgs
void
mavros_msgs__srv__CommandTriggerControl_Request__fini(mavros_msgs__srv__CommandTriggerControl_Request * msg);

/// Create srv/CommandTriggerControl message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * mavros_msgs__srv__CommandTriggerControl_Request__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_mavros_msgs
mavros_msgs__srv__CommandTriggerControl_Request *
mavros_msgs__srv__CommandTriggerControl_Request__create(void);

/// Destroy srv/CommandTriggerControl message.
/**
 * It calls
 * mavros_msgs__srv__CommandTriggerControl_Request__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_mavros_msgs
void
mavros_msgs__srv__CommandTriggerControl_Request__destroy(mavros_msgs__srv__CommandTriggerControl_Request * msg);

/// Check for srv/CommandTriggerControl message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_mavros_msgs
bool
mavros_msgs__srv__CommandTriggerControl_Request__are_equal(const mavros_msgs__srv__CommandTriggerControl_Request * lhs, const mavros_msgs__srv__CommandTriggerControl_Request * rhs);

/// Copy a srv/CommandTriggerControl message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_mavros_msgs
bool
mavros_msgs__srv__CommandTriggerControl_Request__copy(
  const mavros_msgs__srv__CommandTriggerControl_Request * input,
  mavros_msgs__srv__CommandTriggerControl_Request * output);

/// Retrieve pointer to the hash of the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_mavros_msgs
const rosidl_type_hash_t *
mavros_msgs__srv__CommandTriggerControl_Request__get_type_hash(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_mavros_msgs
const rosidl_runtime_c__type_description__TypeDescription *
mavros_msgs__srv__CommandTriggerControl_Request__get_type_description(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the single raw source text that defined this type.
ROSIDL_GENERATOR_C_PUBLIC_mavros_msgs
const rosidl_runtime_c__type_description__TypeSource *
mavros_msgs__srv__CommandTriggerControl_Request__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the recursive raw sources that defined the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_mavros_msgs
const rosidl_runtime_c__type_description__TypeSource__Sequence *
mavros_msgs__srv__CommandTriggerControl_Request__get_type_description_sources(
  const rosidl_message_type_support_t * type_support);

/// Initialize array of srv/CommandTriggerControl messages.
/**
 * It allocates the memory for the number of elements and calls
 * mavros_msgs__srv__CommandTriggerControl_Request__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_mavros_msgs
bool
mavros_msgs__srv__CommandTriggerControl_Request__Sequence__init(mavros_msgs__srv__CommandTriggerControl_Request__Sequence * array, size_t size);

/// Finalize array of srv/CommandTriggerControl messages.
/**
 * It calls
 * mavros_msgs__srv__CommandTriggerControl_Request__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_mavros_msgs
void
mavros_msgs__srv__CommandTriggerControl_Request__Sequence__fini(mavros_msgs__srv__CommandTriggerControl_Request__Sequence * array);

/// Create array of srv/CommandTriggerControl messages.
/**
 * It allocates the memory for the array and calls
 * mavros_msgs__srv__CommandTriggerControl_Request__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_mavros_msgs
mavros_msgs__srv__CommandTriggerControl_Request__Sequence *
mavros_msgs__srv__CommandTriggerControl_Request__Sequence__create(size_t size);

/// Destroy array of srv/CommandTriggerControl messages.
/**
 * It calls
 * mavros_msgs__srv__CommandTriggerControl_Request__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_mavros_msgs
void
mavros_msgs__srv__CommandTriggerControl_Request__Sequence__destroy(mavros_msgs__srv__CommandTriggerControl_Request__Sequence * array);

/// Check for srv/CommandTriggerControl message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_mavros_msgs
bool
mavros_msgs__srv__CommandTriggerControl_Request__Sequence__are_equal(const mavros_msgs__srv__CommandTriggerControl_Request__Sequence * lhs, const mavros_msgs__srv__CommandTriggerControl_Request__Sequence * rhs);

/// Copy an array of srv/CommandTriggerControl messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_mavros_msgs
bool
mavros_msgs__srv__CommandTriggerControl_Request__Sequence__copy(
  const mavros_msgs__srv__CommandTriggerControl_Request__Sequence * input,
  mavros_msgs__srv__CommandTriggerControl_Request__Sequence * output);

/// Initialize srv/CommandTriggerControl message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * mavros_msgs__srv__CommandTriggerControl_Response
 * )) before or use
 * mavros_msgs__srv__CommandTriggerControl_Response__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_mavros_msgs
bool
mavros_msgs__srv__CommandTriggerControl_Response__init(mavros_msgs__srv__CommandTriggerControl_Response * msg);

/// Finalize srv/CommandTriggerControl message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_mavros_msgs
void
mavros_msgs__srv__CommandTriggerControl_Response__fini(mavros_msgs__srv__CommandTriggerControl_Response * msg);

/// Create srv/CommandTriggerControl message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * mavros_msgs__srv__CommandTriggerControl_Response__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_mavros_msgs
mavros_msgs__srv__CommandTriggerControl_Response *
mavros_msgs__srv__CommandTriggerControl_Response__create(void);

/// Destroy srv/CommandTriggerControl message.
/**
 * It calls
 * mavros_msgs__srv__CommandTriggerControl_Response__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_mavros_msgs
void
mavros_msgs__srv__CommandTriggerControl_Response__destroy(mavros_msgs__srv__CommandTriggerControl_Response * msg);

/// Check for srv/CommandTriggerControl message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_mavros_msgs
bool
mavros_msgs__srv__CommandTriggerControl_Response__are_equal(const mavros_msgs__srv__CommandTriggerControl_Response * lhs, const mavros_msgs__srv__CommandTriggerControl_Response * rhs);

/// Copy a srv/CommandTriggerControl message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_mavros_msgs
bool
mavros_msgs__srv__CommandTriggerControl_Response__copy(
  const mavros_msgs__srv__CommandTriggerControl_Response * input,
  mavros_msgs__srv__CommandTriggerControl_Response * output);

/// Retrieve pointer to the hash of the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_mavros_msgs
const rosidl_type_hash_t *
mavros_msgs__srv__CommandTriggerControl_Response__get_type_hash(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_mavros_msgs
const rosidl_runtime_c__type_description__TypeDescription *
mavros_msgs__srv__CommandTriggerControl_Response__get_type_description(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the single raw source text that defined this type.
ROSIDL_GENERATOR_C_PUBLIC_mavros_msgs
const rosidl_runtime_c__type_description__TypeSource *
mavros_msgs__srv__CommandTriggerControl_Response__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the recursive raw sources that defined the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_mavros_msgs
const rosidl_runtime_c__type_description__TypeSource__Sequence *
mavros_msgs__srv__CommandTriggerControl_Response__get_type_description_sources(
  const rosidl_message_type_support_t * type_support);

/// Initialize array of srv/CommandTriggerControl messages.
/**
 * It allocates the memory for the number of elements and calls
 * mavros_msgs__srv__CommandTriggerControl_Response__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_mavros_msgs
bool
mavros_msgs__srv__CommandTriggerControl_Response__Sequence__init(mavros_msgs__srv__CommandTriggerControl_Response__Sequence * array, size_t size);

/// Finalize array of srv/CommandTriggerControl messages.
/**
 * It calls
 * mavros_msgs__srv__CommandTriggerControl_Response__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_mavros_msgs
void
mavros_msgs__srv__CommandTriggerControl_Response__Sequence__fini(mavros_msgs__srv__CommandTriggerControl_Response__Sequence * array);

/// Create array of srv/CommandTriggerControl messages.
/**
 * It allocates the memory for the array and calls
 * mavros_msgs__srv__CommandTriggerControl_Response__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_mavros_msgs
mavros_msgs__srv__CommandTriggerControl_Response__Sequence *
mavros_msgs__srv__CommandTriggerControl_Response__Sequence__create(size_t size);

/// Destroy array of srv/CommandTriggerControl messages.
/**
 * It calls
 * mavros_msgs__srv__CommandTriggerControl_Response__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_mavros_msgs
void
mavros_msgs__srv__CommandTriggerControl_Response__Sequence__destroy(mavros_msgs__srv__CommandTriggerControl_Response__Sequence * array);

/// Check for srv/CommandTriggerControl message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_mavros_msgs
bool
mavros_msgs__srv__CommandTriggerControl_Response__Sequence__are_equal(const mavros_msgs__srv__CommandTriggerControl_Response__Sequence * lhs, const mavros_msgs__srv__CommandTriggerControl_Response__Sequence * rhs);

/// Copy an array of srv/CommandTriggerControl messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_mavros_msgs
bool
mavros_msgs__srv__CommandTriggerControl_Response__Sequence__copy(
  const mavros_msgs__srv__CommandTriggerControl_Response__Sequence * input,
  mavros_msgs__srv__CommandTriggerControl_Response__Sequence * output);

/// Initialize srv/CommandTriggerControl message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * mavros_msgs__srv__CommandTriggerControl_Event
 * )) before or use
 * mavros_msgs__srv__CommandTriggerControl_Event__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_mavros_msgs
bool
mavros_msgs__srv__CommandTriggerControl_Event__init(mavros_msgs__srv__CommandTriggerControl_Event * msg);

/// Finalize srv/CommandTriggerControl message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_mavros_msgs
void
mavros_msgs__srv__CommandTriggerControl_Event__fini(mavros_msgs__srv__CommandTriggerControl_Event * msg);

/// Create srv/CommandTriggerControl message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * mavros_msgs__srv__CommandTriggerControl_Event__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_mavros_msgs
mavros_msgs__srv__CommandTriggerControl_Event *
mavros_msgs__srv__CommandTriggerControl_Event__create(void);

/// Destroy srv/CommandTriggerControl message.
/**
 * It calls
 * mavros_msgs__srv__CommandTriggerControl_Event__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_mavros_msgs
void
mavros_msgs__srv__CommandTriggerControl_Event__destroy(mavros_msgs__srv__CommandTriggerControl_Event * msg);

/// Check for srv/CommandTriggerControl message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_mavros_msgs
bool
mavros_msgs__srv__CommandTriggerControl_Event__are_equal(const mavros_msgs__srv__CommandTriggerControl_Event * lhs, const mavros_msgs__srv__CommandTriggerControl_Event * rhs);

/// Copy a srv/CommandTriggerControl message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_mavros_msgs
bool
mavros_msgs__srv__CommandTriggerControl_Event__copy(
  const mavros_msgs__srv__CommandTriggerControl_Event * input,
  mavros_msgs__srv__CommandTriggerControl_Event * output);

/// Retrieve pointer to the hash of the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_mavros_msgs
const rosidl_type_hash_t *
mavros_msgs__srv__CommandTriggerControl_Event__get_type_hash(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_mavros_msgs
const rosidl_runtime_c__type_description__TypeDescription *
mavros_msgs__srv__CommandTriggerControl_Event__get_type_description(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the single raw source text that defined this type.
ROSIDL_GENERATOR_C_PUBLIC_mavros_msgs
const rosidl_runtime_c__type_description__TypeSource *
mavros_msgs__srv__CommandTriggerControl_Event__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the recursive raw sources that defined the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_mavros_msgs
const rosidl_runtime_c__type_description__TypeSource__Sequence *
mavros_msgs__srv__CommandTriggerControl_Event__get_type_description_sources(
  const rosidl_message_type_support_t * type_support);

/// Initialize array of srv/CommandTriggerControl messages.
/**
 * It allocates the memory for the number of elements and calls
 * mavros_msgs__srv__CommandTriggerControl_Event__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_mavros_msgs
bool
mavros_msgs__srv__CommandTriggerControl_Event__Sequence__init(mavros_msgs__srv__CommandTriggerControl_Event__Sequence * array, size_t size);

/// Finalize array of srv/CommandTriggerControl messages.
/**
 * It calls
 * mavros_msgs__srv__CommandTriggerControl_Event__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_mavros_msgs
void
mavros_msgs__srv__CommandTriggerControl_Event__Sequence__fini(mavros_msgs__srv__CommandTriggerControl_Event__Sequence * array);

/// Create array of srv/CommandTriggerControl messages.
/**
 * It allocates the memory for the array and calls
 * mavros_msgs__srv__CommandTriggerControl_Event__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_mavros_msgs
mavros_msgs__srv__CommandTriggerControl_Event__Sequence *
mavros_msgs__srv__CommandTriggerControl_Event__Sequence__create(size_t size);

/// Destroy array of srv/CommandTriggerControl messages.
/**
 * It calls
 * mavros_msgs__srv__CommandTriggerControl_Event__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_mavros_msgs
void
mavros_msgs__srv__CommandTriggerControl_Event__Sequence__destroy(mavros_msgs__srv__CommandTriggerControl_Event__Sequence * array);

/// Check for srv/CommandTriggerControl message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_mavros_msgs
bool
mavros_msgs__srv__CommandTriggerControl_Event__Sequence__are_equal(const mavros_msgs__srv__CommandTriggerControl_Event__Sequence * lhs, const mavros_msgs__srv__CommandTriggerControl_Event__Sequence * rhs);

/// Copy an array of srv/CommandTriggerControl messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_mavros_msgs
bool
mavros_msgs__srv__CommandTriggerControl_Event__Sequence__copy(
  const mavros_msgs__srv__CommandTriggerControl_Event__Sequence * input,
  mavros_msgs__srv__CommandTriggerControl_Event__Sequence * output);
#ifdef __cplusplus
}
#endif

#endif  // MAVROS_MSGS__SRV__DETAIL__COMMAND_TRIGGER_CONTROL__FUNCTIONS_H_
