// generated from rosidl_typesupport_introspection_cpp/resource/idl__type_support.cpp.em
// with input from mavros_msgs:srv/ParamSetV2.idl
// generated code does not contain a copyright notice

#include "array"
#include "cstddef"
#include "string"
#include "vector"
#include "rosidl_runtime_c/message_type_support_struct.h"
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_interface/macros.h"
#include "mavros_msgs/srv/detail/param_set_v2__functions.h"
#include "mavros_msgs/srv/detail/param_set_v2__struct.hpp"
#include "rosidl_typesupport_introspection_cpp/field_types.hpp"
#include "rosidl_typesupport_introspection_cpp/identifier.hpp"
#include "rosidl_typesupport_introspection_cpp/message_introspection.hpp"
#include "rosidl_typesupport_introspection_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_introspection_cpp/visibility_control.h"

namespace mavros_msgs
{

namespace srv
{

namespace rosidl_typesupport_introspection_cpp
{

void ParamSetV2_Request_init_function(
  void * message_memory, rosidl_runtime_cpp::MessageInitialization _init)
{
  new (message_memory) mavros_msgs::srv::ParamSetV2_Request(_init);
}

void ParamSetV2_Request_fini_function(void * message_memory)
{
  auto typed_message = static_cast<mavros_msgs::srv::ParamSetV2_Request *>(message_memory);
  typed_message->~ParamSetV2_Request();
}

static const ::rosidl_typesupport_introspection_cpp::MessageMember ParamSetV2_Request_message_member_array[3] = {
  {
    "force_set",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_BOOLEAN,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is key
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(mavros_msgs::srv::ParamSetV2_Request, force_set),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "param_id",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_STRING,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is key
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(mavros_msgs::srv::ParamSetV2_Request, param_id),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "value",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<rcl_interfaces::msg::ParameterValue>(),  // members of sub message
    false,  // is key
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(mavros_msgs::srv::ParamSetV2_Request, value),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  }
};

static const ::rosidl_typesupport_introspection_cpp::MessageMembers ParamSetV2_Request_message_members = {
  "mavros_msgs::srv",  // message namespace
  "ParamSetV2_Request",  // message name
  3,  // number of fields
  sizeof(mavros_msgs::srv::ParamSetV2_Request),
  false,  // has_any_key_member_
  ParamSetV2_Request_message_member_array,  // message members
  ParamSetV2_Request_init_function,  // function to initialize message memory (memory has to be allocated)
  ParamSetV2_Request_fini_function  // function to terminate message instance (will not free memory)
};

static const rosidl_message_type_support_t ParamSetV2_Request_message_type_support_handle = {
  ::rosidl_typesupport_introspection_cpp::typesupport_identifier,
  &ParamSetV2_Request_message_members,
  get_message_typesupport_handle_function,
  &mavros_msgs__srv__ParamSetV2_Request__get_type_hash,
  &mavros_msgs__srv__ParamSetV2_Request__get_type_description,
  &mavros_msgs__srv__ParamSetV2_Request__get_type_description_sources,
};

}  // namespace rosidl_typesupport_introspection_cpp

}  // namespace srv

}  // namespace mavros_msgs


namespace rosidl_typesupport_introspection_cpp
{

template<>
ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
get_message_type_support_handle<mavros_msgs::srv::ParamSetV2_Request>()
{
  return &::mavros_msgs::srv::rosidl_typesupport_introspection_cpp::ParamSetV2_Request_message_type_support_handle;
}

}  // namespace rosidl_typesupport_introspection_cpp

#ifdef __cplusplus
extern "C"
{
#endif

ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_introspection_cpp, mavros_msgs, srv, ParamSetV2_Request)() {
  return &::mavros_msgs::srv::rosidl_typesupport_introspection_cpp::ParamSetV2_Request_message_type_support_handle;
}

#ifdef __cplusplus
}
#endif

// already included above
// #include "array"
// already included above
// #include "cstddef"
// already included above
// #include "string"
// already included above
// #include "vector"
// already included above
// #include "rosidl_runtime_c/message_type_support_struct.h"
// already included above
// #include "rosidl_typesupport_cpp/message_type_support.hpp"
// already included above
// #include "rosidl_typesupport_interface/macros.h"
// already included above
// #include "mavros_msgs/srv/detail/param_set_v2__functions.h"
// already included above
// #include "mavros_msgs/srv/detail/param_set_v2__struct.hpp"
// already included above
// #include "rosidl_typesupport_introspection_cpp/field_types.hpp"
// already included above
// #include "rosidl_typesupport_introspection_cpp/identifier.hpp"
// already included above
// #include "rosidl_typesupport_introspection_cpp/message_introspection.hpp"
// already included above
// #include "rosidl_typesupport_introspection_cpp/message_type_support_decl.hpp"
// already included above
// #include "rosidl_typesupport_introspection_cpp/visibility_control.h"

namespace mavros_msgs
{

namespace srv
{

namespace rosidl_typesupport_introspection_cpp
{

void ParamSetV2_Response_init_function(
  void * message_memory, rosidl_runtime_cpp::MessageInitialization _init)
{
  new (message_memory) mavros_msgs::srv::ParamSetV2_Response(_init);
}

void ParamSetV2_Response_fini_function(void * message_memory)
{
  auto typed_message = static_cast<mavros_msgs::srv::ParamSetV2_Response *>(message_memory);
  typed_message->~ParamSetV2_Response();
}

static const ::rosidl_typesupport_introspection_cpp::MessageMember ParamSetV2_Response_message_member_array[2] = {
  {
    "success",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_BOOLEAN,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is key
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(mavros_msgs::srv::ParamSetV2_Response, success),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "value",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<rcl_interfaces::msg::ParameterValue>(),  // members of sub message
    false,  // is key
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(mavros_msgs::srv::ParamSetV2_Response, value),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  }
};

static const ::rosidl_typesupport_introspection_cpp::MessageMembers ParamSetV2_Response_message_members = {
  "mavros_msgs::srv",  // message namespace
  "ParamSetV2_Response",  // message name
  2,  // number of fields
  sizeof(mavros_msgs::srv::ParamSetV2_Response),
  false,  // has_any_key_member_
  ParamSetV2_Response_message_member_array,  // message members
  ParamSetV2_Response_init_function,  // function to initialize message memory (memory has to be allocated)
  ParamSetV2_Response_fini_function  // function to terminate message instance (will not free memory)
};

static const rosidl_message_type_support_t ParamSetV2_Response_message_type_support_handle = {
  ::rosidl_typesupport_introspection_cpp::typesupport_identifier,
  &ParamSetV2_Response_message_members,
  get_message_typesupport_handle_function,
  &mavros_msgs__srv__ParamSetV2_Response__get_type_hash,
  &mavros_msgs__srv__ParamSetV2_Response__get_type_description,
  &mavros_msgs__srv__ParamSetV2_Response__get_type_description_sources,
};

}  // namespace rosidl_typesupport_introspection_cpp

}  // namespace srv

}  // namespace mavros_msgs


namespace rosidl_typesupport_introspection_cpp
{

template<>
ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
get_message_type_support_handle<mavros_msgs::srv::ParamSetV2_Response>()
{
  return &::mavros_msgs::srv::rosidl_typesupport_introspection_cpp::ParamSetV2_Response_message_type_support_handle;
}

}  // namespace rosidl_typesupport_introspection_cpp

#ifdef __cplusplus
extern "C"
{
#endif

ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_introspection_cpp, mavros_msgs, srv, ParamSetV2_Response)() {
  return &::mavros_msgs::srv::rosidl_typesupport_introspection_cpp::ParamSetV2_Response_message_type_support_handle;
}

#ifdef __cplusplus
}
#endif

// already included above
// #include "array"
// already included above
// #include "cstddef"
// already included above
// #include "string"
// already included above
// #include "vector"
// already included above
// #include "rosidl_runtime_c/message_type_support_struct.h"
// already included above
// #include "rosidl_typesupport_cpp/message_type_support.hpp"
// already included above
// #include "rosidl_typesupport_interface/macros.h"
// already included above
// #include "mavros_msgs/srv/detail/param_set_v2__functions.h"
// already included above
// #include "mavros_msgs/srv/detail/param_set_v2__struct.hpp"
// already included above
// #include "rosidl_typesupport_introspection_cpp/field_types.hpp"
// already included above
// #include "rosidl_typesupport_introspection_cpp/identifier.hpp"
// already included above
// #include "rosidl_typesupport_introspection_cpp/message_introspection.hpp"
// already included above
// #include "rosidl_typesupport_introspection_cpp/message_type_support_decl.hpp"
// already included above
// #include "rosidl_typesupport_introspection_cpp/visibility_control.h"

namespace mavros_msgs
{

namespace srv
{

namespace rosidl_typesupport_introspection_cpp
{

void ParamSetV2_Event_init_function(
  void * message_memory, rosidl_runtime_cpp::MessageInitialization _init)
{
  new (message_memory) mavros_msgs::srv::ParamSetV2_Event(_init);
}

void ParamSetV2_Event_fini_function(void * message_memory)
{
  auto typed_message = static_cast<mavros_msgs::srv::ParamSetV2_Event *>(message_memory);
  typed_message->~ParamSetV2_Event();
}

size_t size_function__ParamSetV2_Event__request(const void * untyped_member)
{
  const auto * member = reinterpret_cast<const std::vector<mavros_msgs::srv::ParamSetV2_Request> *>(untyped_member);
  return member->size();
}

const void * get_const_function__ParamSetV2_Event__request(const void * untyped_member, size_t index)
{
  const auto & member =
    *reinterpret_cast<const std::vector<mavros_msgs::srv::ParamSetV2_Request> *>(untyped_member);
  return &member[index];
}

void * get_function__ParamSetV2_Event__request(void * untyped_member, size_t index)
{
  auto & member =
    *reinterpret_cast<std::vector<mavros_msgs::srv::ParamSetV2_Request> *>(untyped_member);
  return &member[index];
}

void fetch_function__ParamSetV2_Event__request(
  const void * untyped_member, size_t index, void * untyped_value)
{
  const auto & item = *reinterpret_cast<const mavros_msgs::srv::ParamSetV2_Request *>(
    get_const_function__ParamSetV2_Event__request(untyped_member, index));
  auto & value = *reinterpret_cast<mavros_msgs::srv::ParamSetV2_Request *>(untyped_value);
  value = item;
}

void assign_function__ParamSetV2_Event__request(
  void * untyped_member, size_t index, const void * untyped_value)
{
  auto & item = *reinterpret_cast<mavros_msgs::srv::ParamSetV2_Request *>(
    get_function__ParamSetV2_Event__request(untyped_member, index));
  const auto & value = *reinterpret_cast<const mavros_msgs::srv::ParamSetV2_Request *>(untyped_value);
  item = value;
}

void resize_function__ParamSetV2_Event__request(void * untyped_member, size_t size)
{
  auto * member =
    reinterpret_cast<std::vector<mavros_msgs::srv::ParamSetV2_Request> *>(untyped_member);
  member->resize(size);
}

size_t size_function__ParamSetV2_Event__response(const void * untyped_member)
{
  const auto * member = reinterpret_cast<const std::vector<mavros_msgs::srv::ParamSetV2_Response> *>(untyped_member);
  return member->size();
}

const void * get_const_function__ParamSetV2_Event__response(const void * untyped_member, size_t index)
{
  const auto & member =
    *reinterpret_cast<const std::vector<mavros_msgs::srv::ParamSetV2_Response> *>(untyped_member);
  return &member[index];
}

void * get_function__ParamSetV2_Event__response(void * untyped_member, size_t index)
{
  auto & member =
    *reinterpret_cast<std::vector<mavros_msgs::srv::ParamSetV2_Response> *>(untyped_member);
  return &member[index];
}

void fetch_function__ParamSetV2_Event__response(
  const void * untyped_member, size_t index, void * untyped_value)
{
  const auto & item = *reinterpret_cast<const mavros_msgs::srv::ParamSetV2_Response *>(
    get_const_function__ParamSetV2_Event__response(untyped_member, index));
  auto & value = *reinterpret_cast<mavros_msgs::srv::ParamSetV2_Response *>(untyped_value);
  value = item;
}

void assign_function__ParamSetV2_Event__response(
  void * untyped_member, size_t index, const void * untyped_value)
{
  auto & item = *reinterpret_cast<mavros_msgs::srv::ParamSetV2_Response *>(
    get_function__ParamSetV2_Event__response(untyped_member, index));
  const auto & value = *reinterpret_cast<const mavros_msgs::srv::ParamSetV2_Response *>(untyped_value);
  item = value;
}

void resize_function__ParamSetV2_Event__response(void * untyped_member, size_t size)
{
  auto * member =
    reinterpret_cast<std::vector<mavros_msgs::srv::ParamSetV2_Response> *>(untyped_member);
  member->resize(size);
}

static const ::rosidl_typesupport_introspection_cpp::MessageMember ParamSetV2_Event_message_member_array[3] = {
  {
    "info",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<service_msgs::msg::ServiceEventInfo>(),  // members of sub message
    false,  // is key
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(mavros_msgs::srv::ParamSetV2_Event, info),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "request",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<mavros_msgs::srv::ParamSetV2_Request>(),  // members of sub message
    false,  // is key
    true,  // is array
    1,  // array size
    true,  // is upper bound
    offsetof(mavros_msgs::srv::ParamSetV2_Event, request),  // bytes offset in struct
    nullptr,  // default value
    size_function__ParamSetV2_Event__request,  // size() function pointer
    get_const_function__ParamSetV2_Event__request,  // get_const(index) function pointer
    get_function__ParamSetV2_Event__request,  // get(index) function pointer
    fetch_function__ParamSetV2_Event__request,  // fetch(index, &value) function pointer
    assign_function__ParamSetV2_Event__request,  // assign(index, value) function pointer
    resize_function__ParamSetV2_Event__request  // resize(index) function pointer
  },
  {
    "response",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<mavros_msgs::srv::ParamSetV2_Response>(),  // members of sub message
    false,  // is key
    true,  // is array
    1,  // array size
    true,  // is upper bound
    offsetof(mavros_msgs::srv::ParamSetV2_Event, response),  // bytes offset in struct
    nullptr,  // default value
    size_function__ParamSetV2_Event__response,  // size() function pointer
    get_const_function__ParamSetV2_Event__response,  // get_const(index) function pointer
    get_function__ParamSetV2_Event__response,  // get(index) function pointer
    fetch_function__ParamSetV2_Event__response,  // fetch(index, &value) function pointer
    assign_function__ParamSetV2_Event__response,  // assign(index, value) function pointer
    resize_function__ParamSetV2_Event__response  // resize(index) function pointer
  }
};

static const ::rosidl_typesupport_introspection_cpp::MessageMembers ParamSetV2_Event_message_members = {
  "mavros_msgs::srv",  // message namespace
  "ParamSetV2_Event",  // message name
  3,  // number of fields
  sizeof(mavros_msgs::srv::ParamSetV2_Event),
  false,  // has_any_key_member_
  ParamSetV2_Event_message_member_array,  // message members
  ParamSetV2_Event_init_function,  // function to initialize message memory (memory has to be allocated)
  ParamSetV2_Event_fini_function  // function to terminate message instance (will not free memory)
};

static const rosidl_message_type_support_t ParamSetV2_Event_message_type_support_handle = {
  ::rosidl_typesupport_introspection_cpp::typesupport_identifier,
  &ParamSetV2_Event_message_members,
  get_message_typesupport_handle_function,
  &mavros_msgs__srv__ParamSetV2_Event__get_type_hash,
  &mavros_msgs__srv__ParamSetV2_Event__get_type_description,
  &mavros_msgs__srv__ParamSetV2_Event__get_type_description_sources,
};

}  // namespace rosidl_typesupport_introspection_cpp

}  // namespace srv

}  // namespace mavros_msgs


namespace rosidl_typesupport_introspection_cpp
{

template<>
ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
get_message_type_support_handle<mavros_msgs::srv::ParamSetV2_Event>()
{
  return &::mavros_msgs::srv::rosidl_typesupport_introspection_cpp::ParamSetV2_Event_message_type_support_handle;
}

}  // namespace rosidl_typesupport_introspection_cpp

#ifdef __cplusplus
extern "C"
{
#endif

ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_introspection_cpp, mavros_msgs, srv, ParamSetV2_Event)() {
  return &::mavros_msgs::srv::rosidl_typesupport_introspection_cpp::ParamSetV2_Event_message_type_support_handle;
}

#ifdef __cplusplus
}
#endif

// already included above
// #include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_cpp/service_type_support.hpp"
// already included above
// #include "rosidl_typesupport_interface/macros.h"
// already included above
// #include "rosidl_typesupport_introspection_cpp/visibility_control.h"
// already included above
// #include "mavros_msgs/srv/detail/param_set_v2__functions.h"
// already included above
// #include "mavros_msgs/srv/detail/param_set_v2__struct.hpp"
// already included above
// #include "rosidl_typesupport_introspection_cpp/identifier.hpp"
// already included above
// #include "rosidl_typesupport_introspection_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_introspection_cpp/service_introspection.hpp"
#include "rosidl_typesupport_introspection_cpp/service_type_support_decl.hpp"

namespace mavros_msgs
{

namespace srv
{

namespace rosidl_typesupport_introspection_cpp
{

// this is intentionally not const to allow initialization later to prevent an initialization race
static ::rosidl_typesupport_introspection_cpp::ServiceMembers ParamSetV2_service_members = {
  "mavros_msgs::srv",  // service namespace
  "ParamSetV2",  // service name
  // the following fields are initialized below on first access
  // see get_service_type_support_handle<mavros_msgs::srv::ParamSetV2>()
  nullptr,  // request message
  nullptr,  // response message
  nullptr,  // event message
};

static const rosidl_service_type_support_t ParamSetV2_service_type_support_handle = {
  ::rosidl_typesupport_introspection_cpp::typesupport_identifier,
  &ParamSetV2_service_members,
  get_service_typesupport_handle_function,
  ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<mavros_msgs::srv::ParamSetV2_Request>(),
  ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<mavros_msgs::srv::ParamSetV2_Response>(),
  ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<mavros_msgs::srv::ParamSetV2_Event>(),
  &::rosidl_typesupport_cpp::service_create_event_message<mavros_msgs::srv::ParamSetV2>,
  &::rosidl_typesupport_cpp::service_destroy_event_message<mavros_msgs::srv::ParamSetV2>,
  &mavros_msgs__srv__ParamSetV2__get_type_hash,
  &mavros_msgs__srv__ParamSetV2__get_type_description,
  &mavros_msgs__srv__ParamSetV2__get_type_description_sources,
};

}  // namespace rosidl_typesupport_introspection_cpp

}  // namespace srv

}  // namespace mavros_msgs


namespace rosidl_typesupport_introspection_cpp
{

template<>
ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_service_type_support_t *
get_service_type_support_handle<mavros_msgs::srv::ParamSetV2>()
{
  // get a handle to the value to be returned
  auto service_type_support =
    &::mavros_msgs::srv::rosidl_typesupport_introspection_cpp::ParamSetV2_service_type_support_handle;
  // get a non-const and properly typed version of the data void *
  auto service_members = const_cast<::rosidl_typesupport_introspection_cpp::ServiceMembers *>(
    static_cast<const ::rosidl_typesupport_introspection_cpp::ServiceMembers *>(
      service_type_support->data));
  // make sure all of the service_members are initialized
  // if they are not, initialize them
  if (
    service_members->request_members_ == nullptr ||
    service_members->response_members_ == nullptr ||
    service_members->event_members_ == nullptr)
  {
    // initialize the request_members_ with the static function from the external library
    service_members->request_members_ = static_cast<
      const ::rosidl_typesupport_introspection_cpp::MessageMembers *
      >(
      ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<
        ::mavros_msgs::srv::ParamSetV2_Request
      >()->data
      );
    // initialize the response_members_ with the static function from the external library
    service_members->response_members_ = static_cast<
      const ::rosidl_typesupport_introspection_cpp::MessageMembers *
      >(
      ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<
        ::mavros_msgs::srv::ParamSetV2_Response
      >()->data
      );
    // initialize the event_members_ with the static function from the external library
    service_members->event_members_ = static_cast<
      const ::rosidl_typesupport_introspection_cpp::MessageMembers *
      >(
      ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<
        ::mavros_msgs::srv::ParamSetV2_Event
      >()->data
      );
  }
  // finally return the properly initialized service_type_support handle
  return service_type_support;
}

}  // namespace rosidl_typesupport_introspection_cpp

#ifdef __cplusplus
extern "C"
{
#endif

ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_service_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__SERVICE_SYMBOL_NAME(rosidl_typesupport_introspection_cpp, mavros_msgs, srv, ParamSetV2)() {
  return ::rosidl_typesupport_introspection_cpp::get_service_type_support_handle<mavros_msgs::srv::ParamSetV2>();
}

#ifdef __cplusplus
}
#endif
